MODULE_NAME='D_B_UI_mod' (DEV vdvAmp, DEV dvTP, INTEGER nBtn_Amp[], INTEGER nLvl_Amp[])


#INCLUDE 'SNAPI.AXI'

(***********************************************************)
(*               CONSTANT DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_CONSTANT


POLL_POWER_STATUS		= 309	// Discrete: Power status
POWER_STATUS_FB			= 409	// Feedback: Power Status feedback
GENERAL_ERROR_FB		= 410	// Feedback: General Error
AMP_CHANNEL_ERROR_FB		= 411	// Feedback: Amplifier Channel Error
POLL_AMP_NAME			= 312	// Amplifier Device Name
POLL_AMP_PRESET_NO		= 313	// Discrete: Poll the selected AmpPreset Number
POLL_AMP_PRESET_NAME		= 314	// Discrete: Poll the name of the selected AmpPreset
POLL_AMP_PRESET_MOD		= 315	// Discrete: Poll to see if the selected AmpPreset modified
AMP_PRESET_MOD_FB		= 415	// Feedback: Is the selected AmpPreset modified 
LOAD_AMP_PRESET_1		= 321	// Discrete: Switch to AmpPreset No 1
LOAD_AMP_PRESET_2		= 322	// Discrete: Switch to AmpPreset No 2
LOAD_AMP_PRESET_3		= 323	// Discrete: Switch to AmpPreset No 3
LOAD_AMP_PRESET_4		= 324	// Discrete: Switch to AmpPreset No 4
LOAD_AMP_PRESET_5		= 325	// Discrete: Switch to AmpPreset No 5
LOAD_AMP_PRESET_6		= 326	// Discrete: Switch to AmpPreset No 6
LOAD_AMP_PRESET_7		= 327	// Discrete: Switch to AmpPreset No 7
LOAD_AMP_PRESET_8		= 328	// Discrete: Switch to AmpPreset No 8
LOAD_AMP_PRESET_9		= 329	// Discrete: Switch to AmpPreset No 9
LOAD_AMP_PRESET_10_BACKUP_13	= 330	// Discrete: Backup current AmpSettings to No 13 and switch to AmpPreset No 10
LOAD_AMP_PRESET_11_BACKUP_14	= 331	// Discrete: Backup current AmpSettings to No 14 and switch to AmpPreset No 11
LOAD_AMP_PRESET_12_BACKUP_15	= 332	// Discrete: Backup current AmpSettings to No 15 and switch to AmpPreset No 12
RESTORE_FROM_13			= 333	// Discrete: Switch to AmpPreset No 13
RESTORE_FROM_14			= 334	// Discrete: Switch to AmpPreset No 14
RESTORE_FROM_15			= 335	// Discrete: Switch to AmpPreset No 15

// The status of following channels is not read at start up
// They are set to INVALID and have to be polled once if they are needed 
DELAY				= 300	// Momentary: Cycle
POLL_DELAY			= 400	// Poll for feedback
DELAY_FB			= 400	// Feedback:
EQ				= 301	// Momentary: Cycle
POLL_EQ				= 401	// Poll for feedback 
EQ_FB				= 401	// Feedback:
LOADMONITORING			= 302	// Momentary: Cycle
POLL_LOADMONITORING		= 402	// Poll for feedback
LOADMONITORING_FB		= 402	// Feedback:
FILTER1				= 303	// Momentary: Cycle
POLL_FILTER1			= 403	// Poll for feedback	
FILTER1_FB			= 403	// Feedback:
FILTER2				= 304	// Momentary: Cycle
POLL_FILTER2			= 404	// Poll for feedback
FILTER2_FB			= 404	// Feedback:	
POLL_AMPTEMPERATURE		= 307	// Poll for feedback 
INPUTMONITORING_A1		= 336	// Momentary: Cycle
POLL_INPUTMONITORING_A1		= 436	// Poll for feedback
INPUTMONITORING_A1_FB		= 436	// Feedback
INPUTMONITORING_A2		= 337	// Momentary: Cycle
POLL_INPUTMONITORING_A2		= 437	// Poll for feedback
INPUTMONITORING_A2_FB		= 437	// Feedback
INPUTMONITORING_A3		= 338	// Momentary: Cycle
POLL_INPUTMONITORING_A3		= 438	// Poll for feedback
INPUTMONITORING_A3_FB		= 438	// Feedback
INPUTMONITORING_A4		= 339	// Momentary: Cycle
POLL_INPUTMONITORING_A4		= 439	// Poll for feedback
INPUTMONITORING_A4_FB		= 439	// Feedback
INPUTMONITORING_D1		= 340	// Momentary: Cycle
POLL_INPUTMONITORING_D1		= 440	// Poll for feedback
INPUTMONITORING_D1_FB		= 440	// Feedback
INPUTMONITORING_D2		= 341	// Momentary: Cycle
POLL_INPUTMONITORING_D2		= 441	// Poll for feedback
INPUTMONITORING_D2_FB		= 441	// Feedback
INPUTMONITORING_D3		= 342	// Momentary: Cycle
POLL_INPUTMONITORING_D3		= 442	// Poll for feedback
INPUTMONITORING_D3_FB		= 442	// Feedback
INPUTMONITORING_D4		= 343	// Momentary: Cycle
POLL_INPUTMONITORING_D4		= 443	// Poll for feedback
INPUTMONITORING_D4_FB		= 443	// Feedback


(***********************************************************)
(*               VARIABLE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_VARIABLE

VOLATILE CHAR TEST[100]
VOLATILE INTEGER ampPresetNo = 0
INTEGER nVolumeLevelStore

//*******************************************************************
// Function : updateFeedback                                        *
// Purpose  : to update fb to the touch panel when AmpPresets change*
// Params   : none                                                  *
// Return   : none                                                  *
//*******************************************************************
define_function updateFeedback()
{
    // Do only poll channels which are displayed
    PULSE[vdvAmp, POLL_INPUTMONITORING_A1] 
    PULSE[vdvAmp, POLL_INPUTMONITORING_A2] 
    PULSE[vdvAmp, POLL_INPUTMONITORING_A3] 
    PULSE[vdvAmp, POLL_INPUTMONITORING_A4] 
    PULSE[vdvAmp, POLL_INPUTMONITORING_D1] 
    PULSE[vdvAmp, POLL_INPUTMONITORING_D2] 
    PULSE[vdvAmp, POLL_INPUTMONITORING_D3] 
    PULSE[vdvAmp, POLL_INPUTMONITORING_D4] 
    PULSE[vdvAmp, POLL_LOADMONITORING] 
}

(***********************************************************)
(*                  THE EVENTS GO BELOW                    *)
(***********************************************************)
DEFINE_EVENT


// Amp control (Power On, Power Off, Power toggle, Cycle Mute, Mute Discrete, Volume +, Volume -,...)
BUTTON_EVENT[dvTP,nBtn_Amp]
{
    PUSH:
    {
	STACK_VAR INTEGER nBtnIdx
	nBtnIdx = GET_LAST(nBtn_Amp)
	    TO[BUTTON.INPUT]	// Solange gedrckt Feedback
	SWITCH(nBtnIdx)
	{
	    CASE 1: { PULSE[vdvAmp, PWR_ON] }
	    CASE 2: { PULSE[vdvAmp, PWR_OFF]}
	    CASE 3: { PULSE[vdvAmp, POWER] }
	    CASE 4: { PULSE[vdvAmp, VOL_MUTE] } // Cycle MUTE
	    CASE 5: { ON[vdvAmp, VOL_MUTE_ON] } // OFF[vdvAmp, VOL_MUTE_ON] to switch off
	    CASE 6: { TO[vdvAmp, VOL_UP] }
	    CASE 7: { TO[vdvAmp, VOL_DN] }
	    CASE 8: { PULSE[vdvAmp,LOAD_AMP_PRESET_1] }
	    CASE 9: { PULSE[vdvAmp,LOAD_AMP_PRESET_2] }	
	    CASE 10: { PULSE[vdvAmp,LOAD_AMP_PRESET_3] }	
	    CASE 11: { PULSE[vdvAmp,LOAD_AMP_PRESET_4] }	
	    CASE 12: { PULSE[vdvAmp,LOAD_AMP_PRESET_5] }	
	    CASE 13: { PULSE[vdvAmp,LOAD_AMP_PRESET_6] }	
	    CASE 14: { PULSE[vdvAmp,LOAD_AMP_PRESET_7] }	
	    CASE 15: { PULSE[vdvAmp,LOAD_AMP_PRESET_8] }	
	    CASE 16: { PULSE[vdvAmp,LOAD_AMP_PRESET_9] }	
	    CASE 17: { PULSE[vdvAmp,LOAD_AMP_PRESET_10_BACKUP_13] }
	    CASE 18: { PULSE[vdvAmp,LOAD_AMP_PRESET_11_BACKUP_14] }
	    CASE 19: { PULSE[vdvAmp,LOAD_AMP_PRESET_12_BACKUP_15] }
	    CASE 20: { PULSE[vdvAmp,RESTORE_FROM_13] }
	    CASE 21: { PULSE[vdvAmp,RESTORE_FROM_14] }		
	    CASE 22: { PULSE[vdvAmp,RESTORE_FROM_15] }
	    CASE 23: { PULSE[vdvAmp,DELAY] }
	    CASE 24: { PULSE[vdvAmp,EQ] }
	    CASE 25: { PULSE[vdvAmp,LOADMONITORING] }
	    CASE 26: { PULSE[vdvAmp,FILTER1] }
	    CASE 27: { PULSE[vdvAmp,FILTER2] }
	    CASE 30: { PULSE[vdvAmp,POLL_DELAY] }
	    CASE 31: { PULSE[vdvAmp,POLL_EQ] }
	    CASE 32: { PULSE[vdvAmp,POLL_LOADMONITORING] }
	    CASE 33: { PULSE[vdvAmp,POLL_FILTER1] }
	    CASE 34: { PULSE[vdvAmp,POLL_FILTER2] }
	    CASE 37: { PULSE[vdvAmp,POLL_AMPTEMPERATURE] }
	    CASE 38: { PULSE[vdvAmp,POLL_POWER_STATUS	]}
	    CASE 48: { PULSE[vdvAmp,POLL_AMP_PRESET_MOD]}
	    CASE 49: { PULSE[vdvAmp,INPUTMONITORING_A1] }
	    CASE 50: { PULSE[vdvAmp,INPUTMONITORING_A2] }
	    CASE 51: { PULSE[vdvAmp,INPUTMONITORING_A3] }
	    CASE 52: { PULSE[vdvAmp,INPUTMONITORING_A4] }
	    CASE 53: { PULSE[vdvAmp,INPUTMONITORING_D1] }
	    CASE 54: { PULSE[vdvAmp,INPUTMONITORING_D2] }
	    CASE 55: { PULSE[vdvAmp,INPUTMONITORING_D3] }
	    CASE 56: { PULSE[vdvAmp,INPUTMONITORING_D4] }
	}
	// if AmpPresets are used and a it should be displayed that the 
	// AmpPreset was modified poll this flag
	WAIT 15
	{
	    //PULSE[ vdvAmp,POLL_AMP_PRESET_MOD ] 
	}
    }
}

// send level from amp to touch panel
LEVEL_EVENT[vdvAmp, VOL_LVL]
{
    SEND_LEVEL dvTP, nLvl_Amp[1], LEVEL.VALUE
}

// send level from touch panel to amp
level_event[dvTP, nLvl_Amp[1]]
{
    nVolumeLevelStore = level.value
}
button_event[dvTP, nBtn_Amp[48]]
{
    release:
    {
	send_level vdvAmp, VOL_LVL, nVolumeLevelStore
    }
}

// processing events / commands coming from the amp to the touch panel
DATA_EVENT[vdvAmp]
{  
    COMMAND:
    {
	STACK_VAR CHAR DATUM[30]
	
	// STACK_VAR INTEGER nBtnIdx
	DATUM  = remove_string(DATA.TEXT, '-', 1)
	    
	SWITCH(DATUM)
	    {
		// FIND MATCHING STRING AND PARSE REST OF MESSAGE. PROVIDE FEEDBACK TO THE 
		// TOUCH PANEL.
		CASE 'AMP_CHANNEL_ERROR_TXT-': // nBtnIdx 41
		{
		    SEND_COMMAND dvTP, "'^TXT-',itoa(nBtn_Amp[41]),',0,',DATA.TEXT"
		}	
		CASE 'DEV_ERROR_TXT-': // nBtnIdx 42
		{
		    SEND_COMMAND dvTP, "'^TXT-',itoa(nBtn_Amp[42]),',0,',DATA.TEXT"
		}
		CASE 'AMPTEMERATURE-': // nBtnIdx 43
		{
		    SEND_COMMAND dvTP, "'^TXT-',itoa(nBtn_Amp[43]),',0,',DATA.TEXT"
		}
		CASE 'AMP_NAME-': // nBtnIdx 44
		{
		    SEND_COMMAND dvTP, "'^TXT-',itoa(nBtn_Amp[44]),',0,',DATA.TEXT"
		}
		CASE 'AMP_PRESET_NAME-': // nBtnIdx 45
		{
		    SEND_COMMAND dvTP, "'^TXT-',itoa(nBtn_Amp[45]),',0,',DATA.TEXT"
		}
		CASE 'AMP_PRESET_NO-': // nBtnIdx 46
		{
		    if (ampPresetNo != atoi(DATA.TEXT)) 
		    {   // If the AmpPreset changed update the other Channels
			updateFeedback()
		    }
		    ampPresetNo = atoi(DATA.TEXT)
		    SEND_COMMAND dvTP, "'^TXT-',itoa(nBtn_Amp[46]),',0,','No ',DATA.TEXT"
		}
		CASE 'POTI_LEVEL_DB-': // nBtnIdx 47
		{
		    SEND_COMMAND dvTP, "'^TXT-',itoa(nBtn_Amp[47]),',0,',DATA.TEXT"
		}
	    }// END SWITCH(datum)
    }// END COMMAND
}// END DATA_EVENT[]


// }}NSX_DEFINE_EVENT
(***********************************************************)
(*            THE ACTUAL PROGRAM GOES BELOW                *)
(***********************************************************)
DEFINE_PROGRAM // mainline section

WAIT 1
{
    // Amp Control (Power On, Power Off, Power toggle, Cycle Mute, Mute Discrete, Volume +, Volume -,...)
    [dvTP,nBtn_Amp[1]] 	= (([vdvAmp, POWER_FB]))
    [dvTP,nBtn_Amp[2]] 	= (NOT([vdvAmp, POWER_FB]))
    [dvTP,nBtn_Amp[3]] 	= (([vdvAmp, POWER_FB])) 
    [dvTP,nBtn_Amp[4]] 	= (([vdvAmp, VOL_MUTE_FB]))
    [dvTP,nBtn_Amp[5]] 	= (([vdvAmp, VOL_MUTE_FB]))
    [dvTP,nBtn_Amp[23]] = (([vdvAmp,DELAY_FB]))
    [dvTP,nBtn_Amp[24]] = (([vdvAmp,EQ_FB]))
    [dvTP,nBtn_Amp[25]] = (([vdvAmp,LOADMONITORING_FB]))
    [dvTP,nBtn_Amp[26]] = (([vdvAmp,FILTER1_FB]))
    [dvTP,nBtn_Amp[27]] = (([vdvAmp,FILTER2_FB]))
    [dvTP,nBtn_Amp[30]] = (([vdvAmp,DELAY_FB]))
    [dvTP,nBtn_Amp[31]] = (([vdvAmp,EQ_FB]))
    [dvTP,nBtn_Amp[32]] = (([vdvAmp,LOADMONITORING_FB]))
    [dvTP,nBtn_Amp[33]] = (([vdvAmp,FILTER1_FB]))
    [dvTP,nBtn_Amp[34]] = (([vdvAmp,FILTER2_FB]))
    [dvTP,nBtn_Amp[38]] = (([vdvAmp,POWER_STATUS_FB]))
    [dvTP,nBtn_Amp[39]] = (([vdvAmp,GENERAL_ERROR_FB]))
    [dvTP,nBtn_Amp[40]] = (([vdvAmp,AMP_CHANNEL_ERROR_FB]))
    [dvTP,nBtn_Amp[48]] = (([vdvAmp,AMP_PRESET_MOD_FB]))
    [dvTP,nBtn_Amp[49]] = (([vdvAmp,INPUTMONITORING_A1_FB]))
    [dvTP,nBtn_Amp[50]] = (([vdvAmp,INPUTMONITORING_A2_FB]))
    [dvTP,nBtn_Amp[51]] = (([vdvAmp,INPUTMONITORING_A3_FB]))
    [dvTP,nBtn_Amp[52]] = (([vdvAmp,INPUTMONITORING_A4_FB]))
    [dvTP,nBtn_Amp[53]] = (([vdvAmp,INPUTMONITORING_D1_FB]))
    [dvTP,nBtn_Amp[54]] = (([vdvAmp,INPUTMONITORING_D2_FB]))
    [dvTP,nBtn_Amp[55]] = (([vdvAmp,INPUTMONITORING_D3_FB]))
    [dvTP,nBtn_Amp[56]] = (([vdvAmp,INPUTMONITORING_D4_FB]))
    
    [dvTP,nBtn_Amp[8]] 	= ( ampPresetNo == 1 )
    [dvTP,nBtn_Amp[9]] 	= ( ampPresetNo == 2 )
    [dvTP,nBtn_Amp[10]] = ( ampPresetNo == 3 )
    [dvTP,nBtn_Amp[11]] = ( ampPresetNo == 4 )
    [dvTP,nBtn_Amp[12]] = ( ampPresetNo == 5 )
    [dvTP,nBtn_Amp[13]] = ( ampPresetNo == 6 )
    [dvTP,nBtn_Amp[14]] = ( ampPresetNo == 7 )
    [dvTP,nBtn_Amp[15]] = ( ampPresetNo == 8 )
    [dvTP,nBtn_Amp[16]] = ( ampPresetNo == 9 )
    [dvTP,nBtn_Amp[17]] = ( ampPresetNo == 10 )
    [dvTP,nBtn_Amp[18]] = ( ampPresetNo == 11 )
    [dvTP,nBtn_Amp[19]] = ( ampPresetNo == 12 )
    [dvTP,nBtn_Amp[20]] = ( ampPresetNo == 13 )
    [dvTP,nBtn_Amp[21]] = ( ampPresetNo == 14 )
    [dvTP,nBtn_Amp[22]] = ( ampPresetNo == 15 )
}
